local TOCNAME,BOM=...
local L = setmetatable({}, {__index = function (t, k)  
	if BOM.L and BOM.L[k] then 
		return BOM.L[k]
	else
		return "["..k.."]"
	end	
end})

local locales={
	enEN ={ --EN is Master/Fallback
		MsgBuffSingle="%s %s",
		MsgBuffGroup="Group %s %s",
		MsgNextCast="%s @ %s",
		MsgNoSpell="Out of Range or Mana",
		MsgDead="Dead",
		MsgCasting="Busy",
		MsgCombat="Combat",
		MsgEmpty="Nothing to do",
		MsgSomebodyDead="Somebody is dead",
		MsgNeedOneMacroSlot="Need one macro slot!",
	
		Cboxshowminimapbutton="Show minimap button",
		CboxLockMinimapButton="Lock minimap button position",		
		CboxLockMinimapButtonDistance="Minimize minimap button distance",
		CboxAutoOpen="Automatic open/close",
		CboxDeathBlock="Don't cast if somebody is dead",
		CboxNoGroupBuff="Don't use group buff",
		CboxSameZone="Only in same zone",

		HeaderRenew="Renew before it expires (in Seconds)",
		EboxTime60="Duration <=60 sec:",
		EboxTime300="Duration <=5 min:",
		EboxTime600="Duration <=10 min:",
		EboxTime1800="Duration <=30 min:",
		EboxTime3600="Duration <=60 min:",
		
		TTSelfCast="Cast on party/raid or only self",
		TTEnable="Enable/Disable spell",
		TTTarget="Force spell on current Target",
		TTSelectTarget="Select a raid/party member to enable this option",
		
		TabBuff="Buff",
		TabSpells="Spells",
				
		BtnOpen="Open",
		BtnCancel="Cancel",
		BtnSettings="Settings",
		
		Header_TRACKING="Tracking",
		PanelSupportedSpells="Supported Spells",
		HeaderIgnoreGroup="Watch in raid group",
		PanelAbout="About",
		HeaderInfo="Information",
		HeaderUsage="Usage",
		HeaderSlashCommand="Slash commands",
		HeaderCredits="Credits",
		
		SlashSpellBook="Rescan spellbook",
		SlashUpdate="Update macro / list",
		SlashClose="Close BOM window",
		SlashReset="Reset BOM window",
		SlashOpen="Open BOM window",
		
		AboutInfo="<dummy info>",
		AboutUsage="<dummy usage>",
		AboutSlashCommand="<value> can be true, 1, enable, false, 0, disable. If <value> is omitted, the current status switches.",
		AboutCredits="wellcat for the Chinese translation",
		
	},
	
	deDE ={
		MsgBuffSingle="%s %s",
		MsgBuffGroup="Gruppe %s %s",
		MsgNextCast="%s @ %s",
		MsgNoSpell="Außer Reichweite oder kein Mana",
		MsgDead="Gestorben",
		MsgCasting="Beschäftigt",
		MsgCombat="Kampf",
		MsgEmpty="Nichts zu tun",
		MsgSomebodyDead="Irgendjemand ist tot",
		MsgNeedOneMacroSlot="Brauche Platz für ein Macro!",
		
		Cboxshowminimapbutton="Minimap-Icon anzeigen",
		CboxLockMinimapButton="Minimap-Icon-Position sperren",		
		CboxLockMinimapButtonDistance="Minimap-Icon-Entfernung minimieren",
		CboxAutoOpen="Automatisches öffnen/schließen",
		CboxDeathBlock="Nicht buffen, wenn jemand tot ist",
		CboxNoGroupBuff="Kein Gruppenbuff benutzen",
		CboxSameZone="Nur wenn in der gleichen Zone",
		
		TTSelfCast="Wirke auf Gruppe/Raid oder nur auf sich selbst",
		TTEnable="Buffüberwachung ein-/ausschalten",
		TTTarget="Buff dauerhaft auf Ziel halten",
		TTSelectTarget="Wähle ein Gruppenmitglied um diese Option zu wählen.",
		
		TabBuff="Buff",
		TabSpells="Spells",
		
		
		BtnOpen="Öffnen",
		BtnCancel="Abbruch",
		BtnSettings="Einstellungen",
		
		PanelSupportedSpells="Unterstützte Zauber",
		Header_TRACKING="Suche",
		HeaderIgnoreGroup="Im Raid Gruppe überwachen",
		PanelAbout="Über",
		HeaderInfo="Information",
		HeaderUsage="Benutzung",
		HeaderSlashCommand="Befehle",
		HeaderCredits="Credits",
		
		SlashSpellBook="Zauberbuch neu einlesen",
		SlashUpdate="Update Macro / Liste",
		SlashClose="BOM-Fenster schließen",
		SlashReset="BOM-Fenster zurücksetzen",
		SlashOpen="BOM-Fenster öffnen",
		
		AboutInfo="some text",
		AboutUsage="do something",
		AboutSlashCommand="<value> kann true,1,enable,false,0,disable sein. Wird <value> weggelassen, schaltet der aktuelle Status um.",
		AboutCredits="wellcat für die chinesische Übersetzung"
				
	},
	
	zhCN ={ 
		MsgBuffSingle="%s %s", 
		MsgBuffGroup="队伍 %s %s", 
		MsgNextCast="%s @ %s", 
		MsgNoSpell="超出距离或缺蓝", 
		MsgDead="死亡", 
		MsgCombat="战斗", 
		MsgEmpty="无", 
		
		Cboxshowminimapbutton="显示小地图按钮", 
		CboxLockMinimapButton="锁定小地图按钮位置", 
		CboxLockMinimapButtonDistance="最小化最小地图按钮距离", 
		CboxAutoOpen="自动 打开/关闭", 
		CboxDeathBlock="忽略死亡玩家", 
		
		BtnOpen="打开", 
		BtnCancel="取消", 
		BtnSettings="设置", 
		
		Header_TRACKING="跟踪", 
		PanelSupportedSpells="支持的法术", 
		
		SlashSpellBook="重新扫描法术书", 
		SlashUpdate="更新宏/列表", 
		SlashClose="关闭插件窗口", 
		SlashReset="重置插件窗口", 
		SlashOpen="打开插件窗口", 
	},
	
	
}
if GetLocale()~="enEN" then
	BOM.L = locales[GetLocale()] or {}
	setmetatable(BOM.L, {
		__index = locales["enEN"]
	})
else
	BOM.L = locales["enEN"]
end
