local TOCNAME,BOM=...
local L = setmetatable({}, {__index = function (t, k)  
	if BOM.L and BOM.L[k] then 
		return BOM.L[k]
	else
		return "["..k.."]"
	end	
end})

local ResurrectionClass={ "SHAMAN", "PRIEST", "PALADIN" }

BOM.SpellList={	
	"PRIEST",
	---[[
	{singleId=10938, groupId=21562, default=true, -- seelenstärke
		singleFamily={1243,1244,1245,2791,10937,10938},groupFamily={21562,21564},
		singleDuration=1800,groupDuration=3600,
		classes={ "WARRIOR", "MAGE", "ROGUE", "DRUID", "HUNTER", "SHAMAN", "PRIEST", "WARLOCK", "PALADIN" }},
	--]]
	{singleId=14819, groupId=27681, default=true,	-- willenstärke
		singleFamily={14752,14818,14819,27841},
		singleDuration=1800,groupDuration=3600,
		classes={ "MAGE", "DRUID", "HUNTER", "SHAMAN", "PRIEST", "WARLOCK", "PALADIN" }},
	{singleId=10958, groupId=27683, default=false, --schattenschutz
		singleFamily={976,10957,10958},
		singleDuration=600,groupDuration=1200,
		classes={ "WARRIOR", "MAGE", "ROGUE", "DRUID", "HUNTER", "SHAMAN", "PRIEST", "WARLOCK", "PALADIN" }},
	{singleId=6346, default=false, -- fearward
		singleDuration=600,
		classes={ "WARRIOR", "MAGE", "ROGUE", "DRUID", "HUNTER", "SHAMAN", "PRIEST", "WARLOCK", "PALADIN" }},
	{singleId=19266, default=true, isOwn=true}, --Berührung der Schwäche
	{singleId=10952, default=true, isOwn=true, --inneres Feuer
		singleFamily={588,7128,602,1006,10951,10952}}, 
	{singleId=20770, isResurrection=true, default=true, --Auferstehung	
		singleFamily={2006,2010,10880,10881,20770}},
	--]]--
	
	--[[FakePriest - blessingtest
	{singleId=1243, isBlessing=true, cancelForm=true, default=true,--seele1
		classes={ "WARRIOR", "ROGUE"}},
	{singleId=1244, isBlessing=true, default=true,--seele2
		classes={ }},	
	{singleId=1245, isBlessing=true, default=true,--seele3
		classes={ "DRUID",  "SHAMAN", "PRIEST", "PALADIN" }},
	--]]
	
	--[[FakePriest Aura
	{singleId=1243,  isAura=true, default=false}, --1
	{singleId=1244, isAura=true, default=false}, --2
	{singleId=1245, isAura=true, default=false}, --2
	--]]
		
	"DRUID",
	{singleId=9885, groupId=21849, cancelForm=true, default=true,--Gabe/Mal der Wildniss
		singleFamily={1126,5232,6756,5234,8907,9884,9885},groupFamily={21849,21850},
		singleDuration=1800,groupDuration=3600,
		classes={ "WARRIOR", "MAGE", "ROGUE", "DRUID", "HUNTER", "SHAMAN", "PRIEST", "WARLOCK", "PALADIN" }}, 
	{singleId=9910, cancelForm=true, default=false,--Dornen
		singleFamily={467,782,1075,8914,9756,9910},
		singleDuration=600,
		classes={ "WARRIOR", "ROGUE", "DRUID", "SHAMAN", "PALADIN" }},
	{singleId=16864, isOwn=true, cancelForm=true, default=true}, --omen of clarity
	{singleId=5225, isTracking=true, needForm=CAT_FORM, default=true},
	
	"MAGE",
	{singleId=10157, groupId=23028, default=true,	-- arkane intelligenz
		singleFamily={1459,1460,1461,10156,10157},
		singleDuration=1800,groupDuration=3600,
		classes={ "MAGE", "DRUID", "HUNTER", "SHAMAN", "PRIEST", "WARLOCK", "PALADIN" }},
	{singleId=10220, isSeal=true, default=false, --eisrüstung
		singleFamily={7302,7320,10219,10220}},
	{singleId=7301, isSeal=true, default=false, --frostrüstung
		singleFamily={168,7300,7301}},
	{singleId=22783, isSeal=true, default=false, --magische rüstung
		singleFamily={6117,22782,22783}},
	

	"SHAMAN",
	{singleId=20777, isResurrection=true, default=true, --Auferstehung	
		singleFamily={2008,20609,20610,20776,20777}},
	
	"WARLOCK",
	{singleId=5697, default=false, -- Unending Breath
		singleDuration=600,
		classes={ "WARRIOR", "MAGE", "ROGUE", "DRUID", "HUNTER", "SHAMAN", "PRIEST", "WARLOCK", "PALADIN" }},
	{singleId=11743, default=false, -- Große Unsichtbarkeit entdecken
		singleFamily={132,2970,11743},
		singleDuration=600,
		classes={ "WARRIOR", "MAGE", "ROGUE", "DRUID", "HUNTER", "SHAMAN", "PRIEST", "WARLOCK", "PALADIN" }},
	{singleId=28610, isOwn=true, default=false, --Schattenzauberschutz
		singleFamily={6229,11739,11740,28610}},
	{singleId=11735, isOwn=true, default=false, -- Demon Armor
		singleFamily={706,1086,11733,11734,11735}},
	{singleId=696, isOwn=true, default=false, -- Demon skin
		singleFamily={687,696}},	
	{singleId=5500, isTracking=true, default=true}, --Sense Demons
	
	"HUNTER",
	{singleId=20906, isOwn=true, default=true, -- Trueshot Aura
		singleFamily={19506,20905,20906}},
		
	{singleId=13161, isAura=true, default=true}, -- Aspect of the beast
	{singleId=25296, isAura=true, default=true, --Aspect of the Hawk
		singleFamily={13165,14318,14319,14320,14321,14322,25296}},	
	{singleId=13163, isAura=true, default=true}, --Aspect of the monkey
	{singleId=20190, isAura=true, default=true, --Aspect of the wild
		singleFamily={20043,20190}},
	{singleId=5118,  isAura=true, default=false}, --Aspect of the Cheetah
	{singleId=13159, isAura=true, default=false}, --Aspect of the pack
		
	{singleId=1494,  isTracking=true, default=true}, --beast
	{singleId=19878, isTracking=true, default=true}, --dämonen
	{singleId=19879, isTracking=true, default=true}, --drachkin
	{singleId=19880, isTracking=true, default=true}, --elementare
	{singleId=19883, isTracking=true, default=true}, --humanoide
	{singleId=19882, isTracking=true, default=true}, --riesen
	{singleId=19884, isTracking=true, default=true}, --untote
	{singleId=19885, isTracking=true, default=true}, --verborgenes
	
	"PALADIN",
	{singleId=25780, isOwn=true, default=true}, --Righteous Fury
	
	{singleId=20217, isBlessing=true, default=true, --Blessing of Kings 
		singleDuration=300,
		classes={  "MAGE", "HUNTER", "WARLOCK" }},
	{singleId=25291, isBlessing=true, default=true,--Blessing of Might 
		singleFamily={19740,19834,19835,19836,19837,19838,25291},
		singleDuration=300,
		classes={ "WARRIOR", "ROGUE"}},
	{singleId=20911, isBlessing=true, default=true,--Blessing of Sanctuary 
		singleDuration=300,
		classes={ }},
	{singleId=25290, isBlessing=true, default=true,--Blessing of Wisdom -
		singleFamily={19742,19850,19852,19853,19854,25290},
		singleDuration=300,
		classes={ "DRUID",  "SHAMAN", "PRIEST", "PALADIN" }},
 
	{singleId=20164, isSeal=true, default=false}, -- Sanctity seal
	{singleId=20165, isSeal=true, default=false}, -- Seal of Light
	{singleId=20154, isSeal=true, default=false}, --Seal of Righteousness
	{singleId=21084, isSeal=true, default=false}, --Seal of Righteousness		
	{singleId=20166, isSeal=true, default=false}, --Seal of Wisdom
	
	{singleId=10293, isAura=true, default=true, -- Devotion Aura
		singleFamily={465,10290,643,10291,1032,10292,10293}},
	{singleId=10301, isAura=true, default=true, -- Retribution Aura
		singleFamily={7294,10298,10299,10300,10301}},
	{singleId=19746, isAura=true, default=true},--Concentration Aura
	{singleId=19896, isAura=true, default=true, -- Shadow Resistance Aura
		singleFamily={19876,19895,19896}},
	{singleId=19898, isAura=true, default=true, -- Frost Resistance Aura
		singleFamily={19888,19897,19898}},	
	{singleId=19900, isAura=true, default=true, -- Fire Resistance Aura
		singleFamily={19891,19899,19900}},
	{singleId=20218, isAura=true, default=true},--Sanctity Aura
	{singleId=20773, isResurrection=true, default=true, --Auferstehung	
		singleFamily={7328,10322,10324,20772,20773}},	
	{singleId=5502, isTracking=true, default=true}, --sense undead
		
	"TRACKING",	
	{singleId=2383, isTracking=true, default=true}, --kräuter
	{singleId=2580, isTracking=true, default=true}, -- erz
	{singleId=2481, isTracking=true, default=true}, -- Schatzsuche / Zwerge
}

local function SpellLinkFormat(spellId,icon,name,rank)
	--local name, rank, icon, castTime, minRange, maxRange, spellId = GetSpellInfo(spell)
	if spellId==nil then
		return "NIL SPELLID"
	else
		rank=rank or "MISSING RANK"
		name = name or "MISSING NAME"
		icon = icon or "MISSING ICON"
		if rank~="" then
			rank="("..rank..")"
		end
		rank=""
		return "|Hspell:" .. spellId .."|h|r |cff71d5ff" ..string.format(BOM.TxtEscapeIcon,icon).. name..rank.."|r|h"
	end
end
local function SpellLink(spell)
	local name, rank, icon, castTime, minRange, maxRange, spellId = GetSpellInfo(spell)
	--print ("GETLINK",spell,name,rank,icon,castTime,minRange,maxRange,spellId)
	return SpellLinkFormat(spellId,icon,name)
end

function BOM.GetSpells()
	BOM.DBChar.Spell=BOM.DBChar.Spell or {}
	BOM.DBChar.Spell[BOM.BLESSINGID] = BOM.DBChar.Spell[BOM.BLESSINGID] or {}
	
	BOM.Spells={}
	BOM.cancelForm={}
	BOM.AllSpellIds={}
	BOM.SpellIdtoConfig={}
		
	for i,spell in ipairs(BOM.SpellList) do
	
		if type(spell)=="table" then		
			-- save "ConfigID"
			spell.ConfigID=spell.ConfigID or spell.singleId
						
			-- get highest rank and store SpellID=ConfigID
			if spell.singleFamily then
				for sindex,sID in ipairs(spell.singleFamily) do
					BOM.SpellIdtoConfig[sID]=spell.ConfigID
					if IsSpellKnown(sID) then
						spell.singleId=sID
					end
				end				
			end
			if spell.singleId then
				BOM.SpellIdtoConfig[spell.singleId]=spell.ConfigID
			end
			if spell.groupFamily then
				for sindex,sID in ipairs(spell.groupFamily) do
					BOM.SpellIdtoConfig[sID]=spell.ConfigID
					if IsSpellKnown(sID) then
						spell.groupId=sID
					end
				end
			end
			if spell.groupId then
				BOM.SpellIdtoConfig[spell.groupId]=spell.ConfigID
			end
			
			-- GetSpellNames and set default duration
			if spell.singleId then
				local name, rank, icon, castTime, minRange, maxRange, spellId = GetSpellInfo(spell.singleId)				
				spell.single=name
				rank=GetSpellSubtext(spell.singleId) or ""
				spell.singleLink=SpellLinkFormat(spellId,icon,name,rank)
				spell.Icon=icon
				if spell.isTracking then
					spell.TrackingIcon=icon
				end
				if spell.singleDuration and BOM.DBChar.Duration[name]==nil and IsSpellKnown(spell.singleId)then 
					BOM.DBChar.Duration[name]=spell.singleDuration
				end
			end
			if  spell.groupId then
				local name, rank, icon, castTime, minRange, maxRange, spellId = GetSpellInfo(spell.groupId)
				spell.group=name
				rank=GetSpellSubtext(spell.groupId) or ""
				spell.groupLink=SpellLinkFormat(spellId,icon,name,rank)
				if spell.groupDuration and BOM.DBChar.Duration[name]==nil and IsSpellKnown(spell.groupId) then 
					BOM.DBChar.Duration[name]=spell.groupDuration
				end				
			end
		
			-- has Spell? Manacost?
			local add
			if IsSpellKnown(spell.singleId) then
				add=true
				spell.singleMana=0
				local cost=GetSpellPowerCost(spell.single)
				if type(cost)=="table"  then
					for i=1,#cost do
						if cost[i] and cost[i].name=="MANA" then 
							spell.singleMana=cost[i].cost or 0
						end
					end
				end
			end
			if spell.group and IsSpellKnown(spell.groupId) then
				add=true
				spell.groupMana=0
				local cost=GetSpellPowerCost(spell.group)		
				if type(cost)=="table"  then
					for i=1,#cost do
						if cost[i] and cost[i].name=="MANA" then 
							spell.groupMana=cost[i].cost or 0
						end
					end
				end
			end
			
			-- Add 
			if add then
				tinsert(BOM.Spells,spell)
				BOM.Tool.iMerge(BOM.AllSpellIds,spell.singleFamily, spell.groupFamily, spell.singleId, spell.groupId)
								
				if spell.cancelForm then
					BOM.Tool.iMerge(BOM.cancelForm,spell.singleFamily, spell.groupFamily, spell.singleId, spell.groupId)
				end
				
				--setDefaultValues!
				if BOM.DBChar.Spell[spell.ConfigID]==nil then 
					BOM.DBChar.Spell[spell.ConfigID]={}
					BOM.DBChar.Spell[spell.ConfigID].Enable=spell.default or false
					BOM.DBChar.Spell[spell.ConfigID].Class={}
					if BOM.SpellHasClasses(spell) then
						BOM.DBChar.Spell[spell.ConfigID].SelfCast=false
						for ci,class in ipairs(BOM.Tool.Classes) do
							BOM.DBChar.Spell[spell.ConfigID].Class[class]=tContains(spell.classes,class)
						end
						BOM.DBChar.Spell[spell.ConfigID].ForcedTarget={}
					end
				end
				
			end	
		end		
	end
end

local MemberCache={}

local function GetMember(unitid,NameGroup)
	
	local name=(UnitFullName(unitid))
	if name==nil then return nil end
	
	local group=NameGroup and NameGroup[name] or 1
	local guid = UnitGUID(unitid)
	local _, class,link
	if guid then
		 _ , class = GetPlayerInfoByGUID(guid)
		if class then
			link=BOM.Tool.IconClass[class].."|Hunit:"..guid..":"..name.."|h[|c"..RAID_CLASS_COLORS[class].colorStr ..name.."|r]|h"	
		else
			class=""
			link=""
		end
	else
		class=""
		link=""
	end	
	
	MemberCache[unitid]=MemberCache[unitid] or {}
	member=MemberCache[unitid]
	
	member.unitId=unitid
	member.name=name
	member.group=group
	member.distance=BOM.Tool.UnitDistanceSquared(unitid)
	member.isDead=UnitIsDeadOrGhost(unitid)
	member.hasResurrection=false
	member.class=class
	member.link=link
	return member
end

local savedParty,savedPlayerMember 
local buffCache={}
function BOM.GetPartyMembers()
	
	local party
	local playerMember

	if not BOM.PartyUpdateNeeded and savedParty~=nil and savedPlayerMember~=nil then
		local ok=false
		if IsInGroup() or IsInRaid() then 
			if #savedParty==GetNumGroupMembers() then 
				ok=true
			end
		elseif #savedParty==1 then
			ok=true
		end	
		
		if ok then 
			for i,member in ipairs(savedParty) do
				local name=(UnitFullName(member.unitId))
				if name~=member.name then
					ok=false
				end
				
				member.distance=BOM.Tool.UnitDistanceSquared(member.unitId)
				member.isDead=UnitIsDeadOrGhost(member.unitId)
				if not member.isDead or BOM.DeclineResurrection then
					member.hasResurrection=false
				else
					member.hasResurrection=UnitHasIncomingResurrection(member.unitId) or member.hasResurrection
				end
			end
			savedPlayerMember.isDead=UnitIsDeadOrGhost("player")
			BOM.DeclineResurrection=false
		end
		if ok then 
			party= savedParty
			playerMember=savedPlayerMember 
		end
	end
	
	if party==nil or playerMember==nil then
		party={}
	
		if IsInRaid() then 
			local NameGroup={}

			for raidIndex=1,40 do
				local name, rank, subgroup, level, class, fileName, 
						zone, online, isDead, role, isML, combatRole = GetRaidRosterInfo(raidIndex)
				
				if name then
					name=BOM.Tool.Split(name,"-")[1]
					NameGroup[name]=subgroup
				end
			end

			for raidIndex=1,40 do
				local member=GetMember("raid"..raidIndex,NameGroup)
				if member then 
					if UnitIsUnit(member.unitId,"player") then
						playerMember=member
					end
					tinsert(party,member)
				end
			end
			playerMember=playerMember or GetMember("player")
		else
			--if IsInGroup() then
				for groupIndex=1,4 do
					local  member=GetMember("party"..groupIndex)
					if member then 
						tinsert(party, member )
					end
				end		
			--end
			
			if BOM.IsDebug then 
				local  member=GetMember("target")
				if member then 
					tinsert(party, member )
				end
			end
			
			playerMember=GetMember("player")
			tinsert(party,playerMember)		
		end
		savedParty=party
		savedPlayerMember=playerMember
	end
	
	table.sort(party,function (a,b) return a.distance < b.distance end)
	
	BOM.PartyUpdateNeeded=false
	
	local bi=0
	
	for i,member in ipairs(party) do
		if member.buffs== nil then
			member.buffs={}
		else
			wipe(member.buffs)
		end
		for buffIndex =1,BOM.MAXAURAS do 
			local name, icon, count, debuffType, duration, expirationTime, source, isStealable, 
				nameplateShowPersonal, spellId, canApplyAura, isBossDebuff, castByPlayer, nameplateShowAll, timeMod = BOM.UnitAura(member.unitId, buffIndex,"HELPFUL")
			
			
			if spellId and tContains(BOM.AllSpellIds,spellId) then
				bi=bi+1
				if buffCache[bi]==nil then buffCache[bi]={} end
				buffCache[bi].duration=duration
				buffCache[bi].expirationTime=expirationTime
				buffCache[bi].source=source
				member.buffs[BOM.SpellIdtoConfig[spellId]]=buffCache[bi]
			end
		end
	end
	
	return party,playerMember
end

function BOM.GetNeedBuff(party,spell,playerMember)--spellname!
	spell.NeedMember=spell.NeedMember or {}
	spell.NeedGroup=spell.NeedGroup or {}
	spell.DeathGroup=spell.DeathGroup or {}
	wipe(spell.NeedGroup)
	wipe(spell.NeedMember)
	wipe(spell.DeathGroup)
	local SomeBodyDeath=false
	
	if spell.isOwn then
		if not playerMember.isDead then
			if not (playerMember.buffs[spell.ConfigID] and BOM.TimeCheck(playerMember.buffs[spell.ConfigID].expirationTime,playerMember.buffs[spell.ConfigID].duration)) then
				tinsert(spell.NeedMember,playerMember)			
			end		
		end
		
	elseif spell.isResurrection then
		for i,member in ipairs(party) do
			if member.isDead and not member.hasResurrection and not UnitIsFeignDeath(member.unitId) and UnitIsConnected(member.unitId) then
				tinsert(spell.NeedMember,member)
			end
		end	
		
	elseif spell.isTracking then
		if GetTrackingTexture()~=spell.TrackingIcon and (BOM.ForceTracking==nil or BOM.ForceTracking==spell.TrackingIcon) then
			tinsert(spell.NeedMember,playerMember)			
		end	
		
	elseif spell.isAura then
		if BOM.ActivAura ~= spell.ConfigID and (BOM.DBChar.LastAura==nil or BOM.DBChar.LastAura==spell.ConfigID) then
			tinsert(spell.NeedMember,playerMember)			
		end	

	elseif spell.isSeal then
		if BOM.ActivSeal ~= spell.ConfigID and (BOM.DBChar.LastSeal==nil or BOM.DBChar.LastSeal==spell.ConfigID) then
			tinsert(spell.NeedMember,playerMember)			
		end	
	
	else--spells and blessing
		local _,_,_,zonePlayer=UnitPosition("player")
		for i,member in ipairs(party) do
			local _,_,_,zoneUnit=UnitPosition(member.unitId)
			
			local ok=false
			
			if spell.isBlessing then
			
				if BOM.DBChar.Spell[BOM.BLESSINGID][member.name]==nil then 
					if BOM.DBChar.Spell[spell.ConfigID].Class[member.class] and (not IsInRaid() or BOM.WatchGroup[member.group]) and not BOM.DBChar.Spell[spell.ConfigID].SelfCast then
						ok=true
					end
					if BOM.DBChar.Spell[spell.ConfigID].SelfCast and UnitIsUnit(member.unitId,"player") then
						ok=true
					end
				elseif BOM.DBChar.Spell[BOM.BLESSINGID][member.name]==spell.ConfigID then
					ok=true
				end
				
			else			
				if BOM.DBChar.Spell[spell.ConfigID].Class[member.class] and (not IsInRaid() or BOM.WatchGroup[member.group]) and not BOM.DBChar.Spell[spell.ConfigID].SelfCast then
					ok=true
				end
				if BOM.DBChar.Spell[spell.ConfigID].SelfCast and UnitIsUnit(member.unitId,"player") then
					ok=true
				end
				if BOM.DBChar.Spell[spell.ConfigID].ForcedTarget[member.name] then
					ok=true
				end
			end
		
			if ok and UnitIsConnected(member.unitId) and (not BOM.DB.SameZone or zoneUnit==zonePlayer) then
				local found=false
				if member.isDead and not UnitIsFeignDeath(member.unitId) then
					SomeBodyDeath=true	
					spell.DeathGroup[member.group]=true
					
				elseif member.buffs[spell.ConfigID] then	
					found=BOM.TimeCheck(member.buffs[spell.ConfigID].expirationTime, member.buffs[spell.ConfigID].duration) 					
				end
				
				if not found then
					tinsert(spell.NeedMember,member)
					spell.NeedGroup[member.group]=(spell.NeedGroup[member.group] or 0)+1
				end	
				
				
			end
		end
	end
	return SomeBodyDeath
end

function BOM.UpdateMacro(member,spellId)
	if (GetMacroInfo(BOM.MACRONAME))==nil then
		local perAccount, perChar = GetNumMacros()
		local isChar=nil
		if perChar<BOM.MAXCHARACTERMACROS then
			isChar=1
		elseif perAccount>=BOM.MAXACCOUNTMACROS then
			print(BOM.MSGPREFIX.. L.MsgNeedOneMacroSlot)
			return
		end			
		--print ("generate macro",isChar)
		CreateMacro(BOM.MACRONAME, BOM.Icon,"",isChar)
	end
	
	local macroText,icon
	if member and spellId then	
		local name = GetSpellInfo(spellId)
		local rank=GetSpellSubtext(spellId) or ""
		if rank~="" then
			rank="("..rank..")"
		end	
		macroText="#showtooltip\n/bom update\n"..
			(tContains(BOM.cancelForm,spellId) and "/cancelform [nocombat]\n" or "" )..
			"/cast [@"..member.unitId ..",nocombat]".. name..rank .."\n"
		icon=BOM.Icon
	else
		macroText="#showtooltip\n/bom update\n"
		icon=BOM.IconOff
	end

	EditMacro(BOM.MACRONAME,nil,icon,macroText)	
	BOM.MinimapButton:SetTexture("Interface\\ICONS\\"..icon)
end

local function GroupInRange(SpellName,party,groupNb)
	for i,member in ipairs(party) do
		if member.group==groupNb and not (IsSpellInRange(SpellName,member.unitId)==1) then
			return false
		end
	end
	return true
end

local function GetGroupMember(party,groupNb)
	--print("GetGroupMember",party,groupNb)
	for i,member in ipairs(party) do
		if member.group==groupNb then
			return member
		end
	end
	return nil
end

function BOM.TimeCheck(ti,duration)
	if ti==nil or duration==nil or ti==0 or duration==0 then return true end
	local dif
	if duration<=60 then
		dif=BOM.DB.Time60
	elseif duration<=300 then
		dif=BOM.DB.Time300
	elseif duration<=600 then
		dif=BOM.DB.Time600
	elseif duration<=1800 then
		dif=BOM.DB.Time1800
	else
		dif=BOM.DB.Time3600
	end
	if dif+GetTime() < ti then
		ti=ti-dif
		if ti<BOM.MinTimer then
			BOM.MinTimer=ti
		end
		return true
	end
	
	return false
end

local autoCloseHelper
local lastCastId
local lastMember
function BOM.UpdateScan()
	if BOM.Spells==nil then return end
	
	BOM.MinTimer=GetTime()+36000
	
	BuffOmat_ListTab_MessageFrame:Clear()

	if InCombatLockdown() then
		BOM.ForceUpdate=false
		BOM.RepeatUpdate=false
		BuffOmat_ListTab_Button:SetText(L.MsgCombat)
		--BuffOmat_ListTab_Button:Disable() combatlock -imposible!
		return 
	end	
	if UnitIsDeadOrGhost("player") then
		BOM.ForceUpdate=false
		BOM.RepeatUpdate=false
		BOM.UpdateMacro()
		BuffOmat_ListTab_Button:SetText(L.MsgDead)	
		BuffOmat_ListTab_Button:Disable()
		if BOM.DB.AutoOpen and autoCloseHelper then
			BOM:HideWindow()
			autoCloseHelper=false
		end		
		return
	end

	local party,playerMember=BOM.GetPartyMembers()
	
	--reset tracking
	BOM.ForceTracking=nil
	for i,spell in ipairs(BOM.Spells) do
		if spell.isTracking then 
			if BOM.DBChar.Spell[spell.ConfigID].Enable then
				if spell.needForm~=nil then 
					if GetShapeshiftFormID()==spell.needForm then
						BOM.ForceTracking=spell.TrackingIcon
					end
				elseif GetTrackingTexture()==spell.TrackingIcon then
					BOM.DBChar.LastTracking=spell.TrackingIcon
				end
			else
				if BOM.DBChar.LastTracking==spell.TrackingIcon then
					BOM.DBChar.LastTracking=nil
				end
			end	
		end
	end
	if BOM.ForceTracking==nil then
		BOM.ForceTracking=BOM.DBChar.LastTracking
	end
	
	--find activ aura / seal
	BOM.ActivAura=nil
	BOM.ActivSeal=nil
	
	for i,spell in ipairs(BOM.Spells) do
		if playerMember.buffs[spell.ConfigID] then 
			if spell.isAura then 
				if (BOM.ActivAura==nil and BOM.LastAura==spell.ConfigID) or UnitIsUnit(playerMember.buffs[spell.ConfigID].source,"player") then
					if BOM.TimeCheck(playerMember.buffs[spell.ConfigID].expirationTime,playerMember.buffs[spell.ConfigID].duration) then 
						BOM.ActivAura=spell.ConfigID
					end
				end					
			elseif spell.isSeal then 
				if UnitIsUnit(playerMember.buffs[spell.ConfigID].source,"player")  then
					if BOM.TimeCheck(playerMember.buffs[spell.ConfigID].expirationTime,playerMember.buffs[spell.ConfigID].duration) then 
						BOM.ActivSeal=spell.ConfigID
					end
				end
			end
		end
	end
	
	--reset aura/seal
	for i,spell in ipairs(BOM.Spells) do
		if spell.isAura then 
			if BOM.DBChar.Spell[spell.ConfigID].Enable then
				if BOM.ActivAura==spell.ConfigID then
					BOM.DBChar.LastAura=spell.ConfigID
				end
			else
				if BOM.DBChar.LastAura==spell.ConfigID then
					BOM.DBChar.LastAura=nil
				end
			end	
		elseif spell.isSeal then 
			if BOM.DBChar.Spell[spell.ConfigID].Enable then
				if BOM.ActivSeal==spell.ConfigID then
					BOM.DBChar.LastSeal=spell.ConfigID
				end
			else
				if BOM.DBChar.LastSeal==spell.ConfigID then
					BOM.DBChar.LastSeal=nil
				end
			end	
		end
	end
	
	-- who needs a buff!	
	local SomeBodyDeath=false	
	for i,spell in ipairs(BOM.Spells) do
		SomeBodyDeath=BOM.GetNeedBuff(party,spell,playerMember) or SomeBodyDeath
	end
	
	local PlayerMana=UnitPower("player",0) or 0--mana
	BOM.ManaLimit=UnitPowerMax("player",0) or 0
	
	local manaCost=-1
	local castSpellId
	local castMember
	local castLink
	
	local needshow=false
	
	local display={}
	for spellIndex,spell in ipairs(BOM.Spells) do
		if BOM.DBChar.Spell[spell.ConfigID].Enable and (spell.needForm==nil or GetShapeshiftFormID()==spell.needForm) then
	
			if (spell.isOwn or spell.isTracking or spell.isAura or spell.isSeal) then
				if #spell.NeedMember>0 then
					tinsert(display,{string.format(L["MsgBuffSingle"],playerMember.link, spell.singleLink), playerMember.distance})
					needshow=true
						
					if spell.singleMana<BOM.ManaLimit and spell.singleMana>PlayerMana then
						BOM.ManaLimit=spell.singleMana
					end
					
					if (manaCost<spell.singleMana and spell.singleMana<=PlayerMana)  then
						manaCost=spell.singleMana
						castSpellId=spell.singleId
						castLink=spell.singleLink
						castMember=playerMember	
					end
				end
			
			elseif spell.isResurrection then
				if SomeBodyDeath then			
					for memberIndex,member in ipairs(spell.NeedMember) do
						local isInRange=(IsSpellInRange(spell.single,member.unitId)==1)
						if isInRange then
							tinsert(display,{string.format(L["MsgBuffSingle"],member.link, spell.singleLink), member.distance})
						else
							tinsert(display,{string.format(L["MsgBuffSingle"],member.name,spell.single),member.distance})
						end
						needshow=true
						
						if spell.singleMana<BOM.ManaLimit and spell.singleMana>PlayerMana then
							BOM.ManaLimit=spell.singleMana
						end
						-- allways overwrite!
						if spell.singleMana<=PlayerMana and isInRange and (castSpellId~=spell.singleId or not tContains(ResurrectionClass,castMember.class)) then
							manaCost=spell.singleMana
							castSpellId=spell.singleId
							castLink=spell.singleLink
							castMember=member	
						end
					end
									
				end
		
			else
				--Group buff
				if spell.groupMana~=nil and not BOM.DB.NoGroupBuff then
					for groupIndex=1,8 do
						if spell.NeedGroup[groupIndex] and spell.NeedGroup[groupIndex]>=3 then		
							if GroupInRange(spell.group,spell.NeedMember,groupIndex) then 
								tinsert(display,{string.format(L["MsgBuffGroup"],groupIndex,spell.groupLink or spell.group),-2})	

								if spell.groupMana<BOM.ManaLimit and spell.groupMana>PlayerMana then
									BOM.ManaLimit=spell.groupMana
								end

								if (manaCost<spell.groupMana and spell.groupMana<=PlayerMana) and (not spell.DeathGroup[member.group] or not BOM.DB.DeathBlock) then
									manaCost=spell.groupMana
									castSpellId=spell.groupId
									castLink=spell.groupLink or spell.group
									castMember=GetGroupMember(spell.NeedMember,groupIndex)
								end
	
							else
								tinsert(display,{string.format(L["MsgBuffGroup"],groupIndex,spell.group),-1})						
							end
							needshow=true
						end
					end
				end
				-- SINGLE BUFF
				for memberIndex,member in ipairs(spell.NeedMember) do
				
					if spell.singleMana~=nil and (BOM.DB.NoGroupBuff or spell.groupMana==nil or spell.NeedGroup[member.group]==nil or spell.NeedGroup[member.group]<3) then
						
						local isInRange=(IsSpellInRange(spell.single,member.unitId)==1)
						if isInRange then 
							tinsert(display,{string.format(L["MsgBuffSingle"],member.link,spell.singleLink),member.distance})
						else
							tinsert(display,{string.format(L["MsgBuffSingle"],member.name,spell.single),member.distance})
						end
						needshow=true
						
						if spell.singleMana<BOM.ManaLimit and spell.singleMana>PlayerMana then
							BOM.ManaLimit=spell.singleMana
						end
					
						if (manaCost<spell.singleMana and spell.singleMana<=PlayerMana) and not member.isDead and isInRange then
							manaCost=spell.singleMana
							castSpellId=spell.singleId
							castLink=spell.singleLink
							castMember=member	
						end
					elseif BOM.IsDebug then --debug
						local isInRange=(IsSpellInRange(spell.single,member.unitId)==1)
						if isInRange then 
							tinsert(display,{"*"..string.format(L["MsgBuffSingle"],member.link,spell.singleLink ),member.distance})
						else
							tinsert(display,{"*"..string.format(L["MsgBuffSingle"],member.name,spell.single),member.distance})
						end
					
					end
				end				
				
			end
		end
	end	
	
	--BuffOmat_ListTab_MessageFrame:AddMessage(" ")
	
	if needshow or (SomeBodyDeath and tContains(ResurrectionClass,playerMember.class)) then
		if BOM.DB.AutoOpen and not BOM.WindowVisible()   then
			BOM:ShowWindow()
			autoCloseHelper=true
		end
		--BuffOmat_ListTab_MessageFrame:AddMessage(string.format(L["MsgNextCast"],castMember.link or castMember.name,castLink or castSpell))

	else
		if BOM.DB.AutoOpen and autoCloseHelper then
			BOM:HideWindow()
			autoCloseHelper=false
		end
	end
	
	
	table.sort(display,function (a,b) return a[2] > b[2] or (a[2]==b[2] and a[1]>b[1]) end)
	
	for i,txt in ipairs(display) do
		BuffOmat_ListTab_MessageFrame:AddMessage(txt[1])
	end
	
	BOM.ForceUpdate=false
	
	if BOM.PlayerCasting then
		BuffOmat_ListTab_Button:SetText(L.MsgCasting)
		BOM.UpdateMacro(lastMember,lastCastId)	
		BuffOmat_ListTab_Button:Disable()
		BOM.RepeatUpdate=true
	
	elseif castMember and castSpellId then				
		BuffOmat_ListTab_Button:SetText(string.format(L["MsgNextCast"],castLink, castMember.link or castMember.name))
				
		BOM.UpdateMacro(castMember,castSpellId)
		local cdtest=GetSpellCooldown(castSpellId) or 0
		if  cdtest~=0 then
			BOM.CheckCoolDown=castSpellId
			BuffOmat_ListTab_Button:Disable()
		else
			BuffOmat_ListTab_Button:Enable()
		end
		
		lastCastId=castSpellId
		lastMember=castMember
		
		BOM.RepeatUpdate=true
	else
		if #display==0 then
			BuffOmat_ListTab_Button:SetText(L.MsgEmpty)			
			BOM.RepeatUpdate=false
		else
			if SomeBodyDeath and BOM.DB.DeathBlock then
				BuffOmat_ListTab_Button:SetText(L.MsgSomebodyDead)
			else
				BuffOmat_ListTab_Button:SetText(L.MsgNoSpell)
			end
			BOM.RepeatUpdate=true
		end
		BuffOmat_ListTab_Button:Enable()
		BOM.UpdateMacro()
	end
	
end

function BOM.SpellHasClasses(spell)
	return not (spell.isOwn or spell.isResurrection or spell.isSeal or spell.isTracking or spell.isAura)
end
